/* Kelsey Reiman
 * July 2014
 */
 
/* the Creeper object takes in a width (w), height (h), and depth as parameters */

Creeper = function (w,h,d) { 

	//add parameters for materials or textures in the future?
	this.parameters = {	
		w: w,
		h: h,
		d: d 
		};
		  
	
	//SET UP GLOBAL VARIABLES
	 
	//these variables are used for the walking animation
	// var direction = 0;
// 	var rotationX = 0;
// 	var dTheta = 0.7;
// 	var dx = 0.1;
// 	var angle = 0;
	
	
	//these variables set up the proportions of the body parts of the creeper
	var headH = 0.3 * h;
	var headW = w;
	var headD = d;
	
	var bodyH = 0.5 * h;
	var bodyW = w;
	var bodyD = 0.33 * d;
	
	var footH = 0.2 * h;
	var footW = 0.5 * w;
	var footD = 0.33 * d;
	
	//these are like containers for groups of objects in the creeper	
	var creeper = new THREE.Object3D();
	var feet = new THREE.Object3D();
	var upperBody = new THREE.Object3D();
	
	//we will use the same material for most of the creeper except the head
	var creeperMat = new THREE.MeshNormalMaterial();
	
	
	//CONSTRUCT THE CREEPER
	
	//the geometry for the front feet will be the same so we can just make it once
	var footG = new THREE.BoxGeometry(footW,footH,footD);
	footG.applyMatrix( new THREE.Matrix4().makeTranslation(0, -(footH * 0.5), (footD * 0.5)) );
	
	//foot 1 and 2 are the front feet 
	var foot1 = new THREE.Mesh(footG,creeperMat);
	foot1.translateX(-0.5 * footW - 0.1);
	foot1.translateY(footH);
	foot1.translateZ((0.5 * bodyD));
	feet.add(foot1);	
	
	var foot2 = new THREE.Mesh(footG,creeperMat);
	foot2.translateX( 0.5 * footW + 0.1);
	foot2.translateY(footH);
	foot2.translateZ((0.5 * bodyD)	);
	feet.add(foot2);
	
	//the geometry for the back feet will be the same so we can just make it once
	//HOWEVER it is different than the front feet because we want it to rotate
	//around a different point
	var footGBack = new THREE.BoxGeometry(footW,footH,footD);
	footGBack.applyMatrix( new THREE.Matrix4().makeTranslation(0, -(footH * 0.5), -(footD * 0.5)) );
	
	//foot 3 and 4 are the back feet 
	var foot3 = new THREE.Mesh(footGBack,creeperMat);
	foot3.translateX(-0.5 * footW - 0.1);
	foot3.translateY(footH);
	foot3.translateZ((-0.5 * bodyD)	);
	feet.add(foot3);	
	
	var foot4 = new THREE.Mesh(footGBack,creeperMat);
	foot4.translateX( 0.5 * footW + 0.1);
	foot4.translateY(footH);
	foot4.translateZ((-0.5 * bodyD)	);
	feet.add(foot4);
	
	creeper.add(feet);
	
	var bodyG = new THREE.BoxGeometry(bodyW,bodyH,bodyD);
	var body = new THREE.Mesh(bodyG,creeperMat); 			
	upperBody.add(body);
	
	
	//add a new material for steve's head so that one of the faces has 
	//an image mapped on it to differentiate the front
	var material1 = new THREE.MeshBasicMaterial( { map: THREE.ImageUtils.loadTexture('images/grumpy-cat.jpg') } );
	var material2 = new THREE.MeshNormalMaterial();
	var material3 = new THREE.MeshNormalMaterial();
	var material4 = new THREE.MeshNormalMaterial();
	var material5 = new THREE.MeshNormalMaterial();
	var material6 = new THREE.MeshNormalMaterial();

	var materials = [material5,material2,material3,material4,material1,material6];

	var headMaterial = new THREE.MeshFaceMaterial( materials );
	
	
	
	var headG = new THREE.BoxGeometry(headW,headH,headD);
	var head = new THREE.Mesh(headG,headMaterial); 			
	head.translateY((bodyH * 0.5) + (headH * 0.5) + 0.1);

	upperBody.add(head);	
	
	upperBody.translateY(footH + (bodyH * 0.5));
	
	creeper.add(upperBody);	
	scene.add(creeper);
	
	var angle = 0
	var dTheta = 0.3;
	var direction = 1;
	var rotationX = 0;
	var dx = .1
		
	this.walk = function(){
			
			if (direction == 1){
				rotationX += dx;
			}
			
			if (direction == -1){
				rotationX -= dx;
			}
			
			if (rotationX >= (Math.PI / 6) || rotationX <= (-Math.PI / 6)){
				direction = direction * -1; 
			}
			
			foot1.rotation.x = rotationX; //this is in radians!!!
 			foot2.rotation.x = -rotationX;
 			foot3.rotation.x = -rotationX; //this is in radians!!!
 			foot4.rotation.x = rotationX; 	
 			
 			
			var theta = angle * (Math.PI/180.0); // theta is in radians
			creeper.position.x = (40*Math.cos(theta));
			creeper.position.z = (40*Math.sin(theta));
			creeper.rotation.y = -1 * theta;  
			//console.log("steve rotation:" + steve.rotation.y);
			angle += dTheta;			
			
			}
			
		return this;
}  // closes Creeper